//#ifdef ANGELO

#include "Framegrabber_RTV-24.h"

#include <iostream>
using namespace std;

int Framegrabber_RTV24:: VideoSizes[6][2] = {{640, 480}, {768,576}, {320,240}, {384,288}, {160,120}, {192,144}};

//int Framegrabber_RTV24::width = 0;
//int Framegrabber_RTV24::height = 0;
int Framegrabber_RTV24::bpp = 0;

int Framegrabber_RTV24::numPorts = 4;

unsigned char** Framegrabber_RTV24::imageData = NULL;
bool* Framegrabber_RTV24::newBuffer = NULL;
int* Framegrabber_RTV24::width = NULL;
int* Framegrabber_RTV24::height = NULL;



void __stdcall Framegrabber_RTV24::MediaStreamProc ( U32 VideoBufferAddress ,U16 PortNo )
{
	U32 Status;

	U8* BufferAddress0 =  (U8*)VideoBufferAddress;

	AngeloRTV_Get_Int_Status(PortNo,&Status);

	if((Status>>1&0x01)==1)//Channel 0 for each port 
	{}
	else
	{
		return;
	}

	memcpy(imageData[PortNo], BufferAddress0, width[PortNo]*height[PortNo]*bpp);
	newBuffer[PortNo] = true;

}



bool Framegrabber_RTV24::hasNewBuffer (int index)
{
	return newBuffer[index];
}

unsigned char* Framegrabber_RTV24::getBuffer(int index)
{
	return imageData[index];
}

int Framegrabber_RTV24::getWidth(int port)
{
	U32 Size_Byte,ImageWidth,ImageHeight, Start_Address;
	AngeloRTV_Get_Frame(port,&Start_Address,&ImageWidth,&ImageHeight,&Size_Byte);

	return ImageWidth;
}

int Framegrabber_RTV24::getHeight (int port)
{
	U32 Size_Byte,ImageWidth,ImageHeight, Start_Address;
	AngeloRTV_Get_Frame(port,&Start_Address,&ImageWidth,&ImageHeight,&Size_Byte);
	return ImageHeight;
}

Framegrabber_RTV24::VideoFormat Framegrabber_RTV24::findVideoFormat (int width, int height)
{
	int nextWidth = 0;
	int nextHeight = 0;

	for (int i=0; i<6; i++)
	{
		int widthDist = abs(VideoSizes[i][0] - width);
		int heightDist = abs(VideoSizes[i][1] - height);

		if (widthDist < abs(VideoSizes[nextWidth][0] - width))
		{
			nextWidth = i;
		}

		if (heightDist < abs(VideoSizes[nextHeight][1] - height))
		{
			nextHeight = i;
		}
	}

	if (abs(VideoSizes[nextWidth][0]) - width <= abs(VideoSizes[nextHeight][1] - height))
		return (VideoFormat) nextWidth;
	else
		return (VideoFormat) nextHeight;
}

Framegrabber_RTV24::~Framegrabber_RTV24()
{
	for (int i=0; i<numPorts; i++)
	{
		AngeloRTV_Capture_Stop(i);
	}

	for (int i=0; i<numPorts; i++)
	{
		AngeloRTV_Close(i);

		delete [] imageData[i];
		imageData[i] = NULL;
	}

	delete [] imageData;
	imageData = NULL;

	delete [] newBuffer;
	newBuffer = NULL;

	delete [] width;
	width = NULL;

	delete [] height;
	height = NULL;

}


Framegrabber_RTV24::Framegrabber_RTV24 ()
{
	imageData = new unsigned char*[numPorts];
	newBuffer = new bool[numPorts];

	width = new int [numPorts];
	height = new int [numPorts];

	for (int i=0; i<numPorts; i++)
	{
		imageData[i] = NULL;
		newBuffer[i] = false;
	}
}

void Framegrabber_RTV24::open(int port, VideoFormat vf, ColorFormat cf)
{
	bpp = cf;
	width[port] = VideoSizes[vf][0];
	height[port] = VideoSizes[vf][1];

	//cout << width << " " << height << endl;
	
	imageData[port] = new unsigned char[width[port]*height[port]*bpp];
	memset(imageData[port], 125, width[port]*height[port]*bpp);
	AngeloRTV_Initial(port);

	AngeloRTV_Set_Callback(port, MediaStreamProc);

	AngeloRTV_Set_Color_Format(port, cf); // RGB24

	AngeloRTV_Set_Video_Format(port, vf);

	AngeloRTV_Set_Image_Config(port, 5, 0);// 0 for color camera, 1 for monochrome

	AngeloRTV_Select_Channel(port, 1);
	AngeloRTV_Capture_Config(port, 2);

	U32 Size_Byte,ImageWidth,ImageHeight, Start_Address;
	AngeloRTV_Get_Frame(port,&Start_Address,&ImageWidth,&ImageHeight,&Size_Byte);//get the actul image size
	//AngeloRTV_Sync_Grab(port, &Start_Address, &ImageWidth, &ImageHeight, &Size_Byte);

	AngeloRTV_Capture_Start(port, 0xFFFFFFFF);
	
}
