/*
 * ONLY suitable for a single angelo card per computer
 * needs rewrites to be used for more than one angelo card
 * see user manual on how to do this
 *
 */

#ifndef FG_RTV_24_H
#define FG_RTV_24_H

#include <windows.h>

#include "Type_def.h"
#include "Angelo.h"



class Framegrabber_RTV24
{
public:
	
	static enum VideoFormat
	{
		NTSC_FULL,	// 640x480
		PAL_FULL,	// 768x576
		NTSC_CIF,	// 320x240
		PAL_CIF,	// 384x288
		NTSC_QCIF,	// 160x120
		PAL_QCIF	// 192x144
	};

	static int VideoSizes[6][2];

	static enum ColorFormat
	{
		RGB16,
		GRAY,
		RGB15,
		RGB24,
		RGB32,
		RGB8,
		RAW8X,
		YUY24_2_2
	};

	static enum ColorConfigIndex
	{
		BRIGHTNESS,
		HUE,
		SATURATION_U,
		SATURATION_V,
		CONTRAST_LUMA,
		LUMA_NOTCH_FILTER
	};

	Framegrabber_RTV24();
	void open(int port, VideoFormat vf, ColorFormat cf = RGB24);
	
	//Framegrabber_RTV24(VideoFormat vf, ColorFormat cf, int numberOfPorts=4);
	~Framegrabber_RTV24();


	unsigned char* getBuffer (int port);
	bool hasNewBuffer (int port);

	int getWidth(int port);
	int getHeight(int port);

	//static void setNumberOfCams (int numCams);

	VideoFormat findVideoFormat (int width, int height);
	
private:

	static void __stdcall MediaStreamProc ( U32 VideoBufferAddress ,U16 PortNo );

	static unsigned char** imageData;
	static int* width;
	static int* height;
	static int bpp;

	static bool *newBuffer;

	static int numPorts;
};



#endif //FG_RTV_24_H